//+------------------------------------------------------------------+
//|                                                    My expert.mq4 |
//|                                                    .. |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright " .."
#property link      ""

//+------------------------------------------------------------------
                                         //    30
extern double StopLoss     = 20;          // SL   
extern double TakeProfit   = 50;          //    
extern double Lots         = 0.1;         //   . 
extern double TrailingStop = 10;          // Trail stop in points
extern double Prots        = 0.4;         //   

//| expert initialization function                                     |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()                                  //  
  {
  double MA_1Current,MA_1Previous,MA_2Current, MA_2Previous;
  double MA_3Current, MA_3Previous, StochMCurrent, StochMPrevious;
  double StochSCurrent, StochSPrevious, MacdSCurrent, MacdSPrevious;
  int cnt=0, ticket, total;
  
//+------------------------------------------------------------------+
       
                                              //   .
MA_1Current    = iMA(NULL,0,5,0,MODE_EMA,PRICE_CLOSE,0);              // _1 0 
MA_1Previous   = iMA(NULL,0,5,0,MODE_EMA,PRICE_CLOSE,1);              // _1 1 
MA_2Current    = iMA(NULL,0,13,0,MODE_EMA,PRICE_CLOSE,0);             // _2 0 
MA_2Previous   = iMA(NULL,0,13,0,MODE_EMA,PRICE_CLOSE,1);             // _2 1 
MA_3Current    = iMA(NULL,0,34,0,MODE_EMA,PRICE_CLOSE,0);             // _3 0 
MA_3Previous   = iMA(NULL,0,34,0,MODE_EMA,PRICE_CLOSE,1);             // _3 1 
StochMCurrent  = iStochastic(NULL,0,5,3,3,MODE_SMA,0,MODE_MAIN,0);    // Sto_M 0 
StochMPrevious = iStochastic(NULL,0,5,3,3,MODE_SMA,0,MODE_MAIN,1);    // Sto_M 1 
StochSCurrent  = iStochastic(NULL,0,5,3,3,MODE_SMA,0,MODE_SIGNAL,0);  // Sto_S 0 
StochSPrevious = iStochastic(NULL,0,5,3,3,MODE_SMA,0,MODE_SIGNAL,1);  // Sto_S 1 
MacdSCurrent   = iMACD(NULL,0,5,7,3,PRICE_CLOSE,MODE_SIGNAL,0);       // MACD_S 0 
MacdSPrevious  = iMACD(NULL,0,5,7,3,PRICE_CLOSE,MODE_SIGNAL,1);       // MACD_S 1 

                                                   //   . 
total=OrdersTotal(); 
if(total<1)
   {
//+------------------------------------------------------------------+
                                                   //  .
                                   //    .   
                                                   
if (Bid<MA_3Current && MA_1Current<MA_2Current && MA_2Current<MA_3Current &&   
    MacdSCurrent<0 && MacdSPrevious>0 && StochMPrevious>70 && 
    StochMPrevious>StochSPrevious && MA_1Previous>MA_2Previous)
     {   
     ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,3,0,Ask+TakeProfit*Point);
     } 
                                    //    .  
if (Bid>MA_3Current  &&  MA_1Current>MA_2Current  && MA_2Current>MA_3Current &&   
    MacdSCurrent>0  &&  MacdSPrevious<0  &&  StochMPrevious<30 &&  
    StochMPrevious<StochSPrevious  &&  MA_1Previous<MA_2Previous)
     {   
     ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,3,0,Bid-TakeProfit*Point);
     }
    return(0);                          //      ???
  }      
//+------------------------------------------------------------------+
                                                   //  .
for(cnt=0;cnt<total;cnt++)  
   {      
   OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);  
   if(OrderType()<=OP_SELL &&   //   ? OP_BUY  OP_SELL.         
      OrderSymbol()==Symbol())  //  ?       
     {         
      if(OrderType()==OP_BUY)   //   .           
        {
                                //    . 
        if(StochMCurrent>StochSCurrent &&  StochMPrevious<StochSPrevious && 
           MacdSCurrent>MacdSPrevious)
           {
            OrderClose(OrderTicket(),OrderLots(),Bid);      //  .
            return(0);                                      // .
           }
                                //  -   ?
        if(TrailingStop>0) 
          {
           if(Bid-OrderOpenPrice()>Point*TrailingStop)
             {
              if(OrderStopLoss()<Bid-Point*TrailingStop)
                {
                 OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,
                 
                             OrderTakeProfit(),0);
                 return(0);
                }
              }
            }
          }
        else // ,   .
          {
                                //    .
        if(StochMCurrent<StochSCurrent &&  StochMPrevious>StochSPrevious && 
           MacdSCurrent<MacdSPrevious)
          {
           OrderClose(OrderTicket(),OrderLots(),Ask);      //  .
           return(0);                                      // .
          }
                                //  -   ?
        if(TrailingStop>0) 
          {
           if((OrderOpenPrice()-Ask)>(Point*TrailingStop))
             {
              if((OrderStopLoss()>(Ask+Point*TrailingStop)) || (OrderStopLoss()==0))
                {
                 OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,
                             OrderTakeProfit(),0);
                 return(0);
                }
              }
            }
          } 
        }
     return(0);
    }
//. 